﻿using System;

namespace Interfejsy
{
    interface IInterfejsA
    {
        int Wartość { get; }
        void Metoda(int argument);
    }

    namespace Warstwa0
    {
        public class KlasaA : IInterfejsA
        {
            public int Wartość { get; } = 1;

            public void Metoda(int argument)
            {
                Console.WriteLine("Robię coś ważnego: " + argument);
            }
        }

        /*
        public class MockA : IInterfejsA
        {
            public
        }
        */

        public class KlasaAA : IInterfejsA
        {
            public int Wartość
            {
                get
                {
                    return 2;
                }
            }

            public void Metoda(int argument)
            {
                Console.WriteLine("Nie robię niczego ważnego: " + argument);
            }
        }
    }

    namespace Warstwa1
    {
        using Warstwa0;

        class KlasaB
        {
            //KlasaA obiektA;
            IInterfejsA obiektA;

            public KlasaB(IInterfejsA obiektA)
            {
                this.obiektA = obiektA;
            }

            public void JakaśMetoda()
            {
                int wartość = obiektA.Wartość;
                obiektA.Metoda(wartość + 1);
            }
        }
    }


    class Program
    {
        static void Main(string[] args)
        {
            IInterfejsA obiektA = new Warstwa0.KlasaA();
            Warstwa1.KlasaB obiektB = new Warstwa1.KlasaB(obiektA);
            obiektB.JakaśMetoda();
        }
    }
}
